%dbstop if (obj_small == NaN)
%%
function totNetwork = DP_CP(nodeNetwork,pMatrix,CR_Matrix,C_ss,sortData,runBeforeDay,runAfterDay,distinctValueIndecies,maxCap)
%Policy lagres i totNetwork
%% Parametre
    %Tidslinjer
    numBidHours                 = 6;
    numProdHours                = 4;
    %Diskretiseringer    
    numPlevels                  = 5;
    numClevels                  = 4;
    numRlevels                  = 2;
%% Oppretter plass for lagring av data. 
    numDecVar                   = numProdHours*2;
    numStateVar                 = 3;
    numPcomb                    = numPlevels^numProdHours;
    decVarRows                  = 1:numDecVar;
    objValRow                   = numDecVar+1;
    nextIndexRow                = objValRow+1;
    numNodes                    = size(nodeNetwork,1);
    %Verdi av noder i neste steg
    nextStageExVals             = zeros(numNodes/numPcomb,numPcomb); %Satt til null etter siste steg, men her m vi gjre en vurdering for  straffe/belnne ulike R.
    %Policy
    totNetwork                  = nan(numNodes,(numProdHours*numStateVar+(numDecVar+2)*numBidHours));    
    %Setter inn nodeinfo tilsvarende nodeNetwork i totNetwork    
    totNetwork(:,1:(numStateVar*numProdHours))          = nodeNetwork(:,1:(numStateVar*numProdHours));
%% Finner strukturdata om nodeNetwork
    starts                      = sortData(:,1:3);
    intervals                   = sortData(:,4:6);
    repeats                     = sortData(:,7:9);            
%% Backward recursion
    for bh = numBidHours:-1:1
        tic
        disp('New stage:')
        bh
    %% Finner relevante noder
%         if bh <= 3
%             distinctValueNodes = find(~distinctValueIndecies(:,bh));
%         else 
%             distinctValueNodes = find(distinctValueIndecies(:,bh));
%         end        
    %% Lser for relevante noder    
        parfor ii = 1:length(distinctValueNodes)
            nn = distinctValueNodes(ii);
            pp = mod(nn-1,numPcomb)+1;        %Finner hvilken pris pp som tilhrer noden nn

            capLeftVec              = nodeNetwork(nn,1:numProdHours);
            priceVec                = nodeNetwork(nn,1+numProdHours:2*numProdHours);
            runningVec              = nodeNetwork(nn,1+2*numProdHours:3*numProdHours);
            MC_vec_t                = nodeNetwork(nn,1+3*numProdHours:4*numProdHours);
            
            [maxValue optimalSolutionVec maxIndex]  = objValAndDecisions_CP(priceVec,capLeftVec,runningVec,nextStageExVals(:,pp)',CR_Matrix,C_ss,MC_vec_t,bh,nn,intervals(:,2),runBeforeDay,runAfterDay,maxCap);
            temp                                    = [maxValue optimalSolutionVec(10:17) maxIndex];

            saveObjValues(ii)   = temp(1);
            saveX_sell_Var1(ii) = temp(2);
            saveX_sell_Var2(ii) = temp(3);
            saveX_sell_Var3(ii) = temp(4);
            saveX_sell_Var4(ii) = temp(5);
            saveX_buy_Var1(ii)  = temp(6);
            saveX_buy_Var2(ii)  = temp(7);
            saveX_buy_Var3(ii)  = temp(8);
            saveX_buy_Var4(ii)  = temp(9);
            saveMaxIndex(ii)    = temp(10);
        end
        toc        
    %% Lagrer decision variables og objective value i totNetwork
        disp('Save values')
        tic
        for ii = 1:length(distinctValueNodes)
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(1)) = saveX_sell_Var1(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(2)) = saveX_sell_Var2(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(3)) = saveX_sell_Var3(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(4)) = saveX_sell_Var4(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(5)) = saveX_buy_Var1(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(6)) = saveX_buy_Var2(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(7)) = saveX_buy_Var3(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(8)) = saveX_buy_Var4(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+objValRow) = saveObjValues(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow) = saveMaxIndex(ii);
%             totNetwork(ii,numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(1)) = saveX_sell_Var1(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(2)) = saveX_sell_Var2(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(3)) = saveX_sell_Var3(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(4)) = saveX_sell_Var4(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(5)) = saveX_buy_Var1(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(6)) = saveX_buy_Var2(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(7)) = saveX_buy_Var3(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(8)) = saveX_buy_Var4(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+objValRow) = saveObjValues(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow) = saveMaxIndex(ii);
        end
        
%         %Lagrer tilsvarende rader med samme verdier
        if bh > 3
        next_ph             = bh-2;
        equalValueInterval  = intervals(next_ph,1);
        firstIndex          = 1;
        counter             = 0;
        bidHourInterval     = (numStateVar*numProdHours+(bh-1)*nextIndexRow+1):(numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow);        
        while firstIndex < numNodes           
            firstIndexP = firstIndex;          
            while firstIndexP < (repeats(next_ph,1)+(intervals(next_ph,2)*counter))
                indiceInterval  = firstIndexP:(firstIndexP+equalValueInterval-1);
                calcValueVector = repmat(totNetwork(firstIndexP,bidHourInterval),equalValueInterval,1);
                firstIndexP     = firstIndexP + equalValueInterval;                
                totNetwork(indiceInterval,bidHourInterval) = calcValueVector; 
            end
            
            %Har n regnet ut for 5 (opp til 625) priser, for frste R-kombinasjon.
            %De neste radene har samme C og P for ph_next, pluss samme R
            %for ph-1. De har derfor samme verdier og kan kopieres av
            %intervallene ovenfor. Dette gjres inntil man nr raden der
            %R(ph-1) endrer seg.
            %M oppdatere for riktig saveMaxIndex som tilsvarer HELE capVec

            firstIndexC         = firstIndexP;
            lengthOfInterval    = firstIndexP-firstIndex;
            bidHourInterval_U_maxIndex = (numStateVar*numProdHours+(bh-1)*nextIndexRow+1):((numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow)-1);
            bidHourMaxIndex = (numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow);
            mellomCounter = 1;
            counterCap = 0;
            
            while firstIndexC < (starts(next_ph-1,3)+(intervals(next_ph,2)*counter))
                indiceInterval  = firstIndexC:(firstIndexC+lengthOfInterval-1);
                calcValueVector = totNetwork((firstIndex:firstIndexP-1),bidHourInterval_U_maxIndex);
                firstIndexC     = firstIndexC + lengthOfInterval;                
                totNetwork(indiceInterval,bidHourInterval_U_maxIndex) = calcValueVector; 
                if mellomCounter == numPlevels^(numBidHours-bh)
                    counterCap = counterCap+1;
                    mellomCounter = 1;
                else
                    mellomCounter = mellomCounter+1;
                end
                totNetwork(indiceInterval,bidHourMaxIndex) = totNetwork((firstIndex:firstIndexP-1),bidHourMaxIndex)+ones(lengthOfInterval,1)*counterCap;
            end
            
            %Har n regnet ut verdi for alle noder med samme C(ph) og
            %R(ph-1). N m tilsvarende C(ph) regnes ut for motsatte
            %R(ph-1), for alle 5 (opp til 625) priser.
            
            firstIndexR         = firstIndexC;
            
            while (firstIndexR-firstIndexC) < repeats(next_ph,1)
                indiceInterval  = firstIndexR:(firstIndexR+equalValueInterval-1);
                calcValueVector = repmat(totNetwork(firstIndexR,bidHourInterval),equalValueInterval,1);
                firstIndexR     = firstIndexR + equalValueInterval;               
                totNetwork(indiceInterval,bidHourInterval) = calcValueVector; 
            end
            
            %Forrige intervall kan kopieres inn i alle noder med
            %tilsvarende C(ph) og R(ph-1). Gjres frem til man nr en ny
            %C(ph).
            
            lengthOfInterval = firstIndexR-firstIndexC;
            firstIndexC2 = firstIndexR;
            bidHourInterval_U_maxIndex = (numStateVar*numProdHours+(bh-1)*nextIndexRow+1):((numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow)-1);
            bidHourMaxIndex = (numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow);
            mellomCounter = 1;
            counterCap = 0;
            
            while firstIndexC2 < (intervals(next_ph,2)+(intervals(next_ph,2)*counter))
                indiceInterval  = firstIndexC2:(firstIndexC2+lengthOfInterval-1);
                calcValueVector = totNetwork((firstIndexC:firstIndexR-1),bidHourInterval_U_maxIndex);
                firstIndexC2     = firstIndexC2 + lengthOfInterval;                
                totNetwork(indiceInterval,bidHourInterval_U_maxIndex) = calcValueVector; 
                if mellomCounter == numPlevels^(numBidHours-bh)
                    counterCap = counterCap+1;
                    mellomCounter = 1;
                else
                    mellomCounter = mellomCounter+1;
                end
                totNetwork(indiceInterval,bidHourMaxIndex) = totNetwork((firstIndexC:firstIndexR-1),bidHourMaxIndex)+ones(lengthOfInterval,1)*counterCap;
            end            
            firstIndex          = firstIndexC2;
            counter             = counter + 1;
        end
        end
         toc
    %% Regner expected future values
        disp('Expected comp')
        tic
        %Finner expected values av  velge en spesifikk future state (R,C) = nn,
        %gitt en nvrende pris = pp.
        for pp = 1:numPcomb
            for nn = 1:numNodes/numPcomb
                rows = (nn-1)*numPcomb+1:nn*numPcomb;
                column = numStateVar*numProdHours+(bh-1)*nextIndexRow+objValRow;
                nextStageExVals(nn,pp) = sum(totNetwork(rows,column).*pMatrix(pp,:)');       %Size = 256x625
            end
        end
        toc
    end
    %% Sender output til findBounds
    output = totNetwork;
    
    %% pner fil for lagring av data (Dette skjer n i findBounds)
    %Data som lagres: objektivverdier Obj og beslutningsvariable (Var)
    %Struktur p data: Obj Varx8 Obj Varx8 Obj Varx8 Obj Varx8
    %De ni frste kolonnene tilhrer budtime 1, de ni neste budtime 2 osv
    %Hver rad tilsvarer noder med tilsvarende statevariable C R P
    
%     [fid msg] = fopen('testFile','w');
%     if (fid > -1)
%         numElemSaved = fwrite(fid,totNetwork,'double');
%         if numElemSaved 
%             disp('Elementene er lagret');
%         else 
%             disp('Noe kan ha gtt galt under lagring');
%         end
%     else
%         output = 0
%         disp(msg);
%     end
%     status = fclose(fid)
end