function [deterministicObjective deterministicPolicy] = createDeterministic_DP_CP(nodeNetwork,CR_Matrix,C_ss,sortData,runBeforeDay,runAfterDay,simPricePath,maxCap)
%Policy lagres i totNetwork
%% Parametre
    %Tidslinjer
    numBidHours                 = 6;
    numProdHours                = 4;
    %Diskretiseringer    
    numPlevels                  = 5;
    numClevels                  = 4;
    numRlevels                  = 2;
%% Oppretter plass for lagring av data.    
    numDecVar                   = numProdHours*2;
    numStateVar                 = 3;
    numPcomb                    = numPlevels^numProdHours;
    numCcomb                    = numClevels^numProdHours;
    decVarRows                  = 1:numDecVar;
    objValRow                   = numDecVar+1;
    nextIndexRow                = objValRow+1;
    numNodes                    = size(nodeNetwork,1);
    %Verdi av noder i neste steg
    nextStageExVals             = zeros(numNodes/numPcomb,1); %Satt til null etter siste steg, men her m vi gjre en vurdering for  straffe/belnne ulike R.
    %Policy
    totNetwork                  = nan(numNodes,(numProdHours*numStateVar+(numDecVar+2)*numBidHours));
    %Setter inn nodeinfo tilsvarende nodeNetwork i totNetwork
    totNetwork(:,1:(numStateVar*numProdHours))          = nodeNetwork(:,1:(numStateVar*numProdHours));
%% Finner strukturdata om nodeNetwork
    starts                      = sortData(:,1:3);
    intervals                   = sortData(:,4:6);
    repeats                     = sortData(:,7:9);
%% Finner priskombinasjonen
    pp = simPricePath;
    priceVecs = nodeNetwork(pp,1+numProdHours:2*numProdHours); 
    %% Backward recursion
    for bh = numBidHours:-1:1          
    %% Finner relevante noder    
        %Lser for relevante noder (C-kombinasjoner)
        %Maks lengde = 256
        distinctValueIndecies           = zeros(numNodes,1);
        next_ph                         = bh - 2;
        index                           = pp(bh);
        if next_ph > 0
            Cinterval   = intervals(next_ph,2);
            if next_ph-1 > 0
                Rchange     = starts(next_ph-1,3);
            else
                Rchange     = 0;
            end
        else
            Cinterval   = intervals(1,2);
            Rchange     = 0;
        end
        while index < length(distinctValueIndecies)
            distinctValueIndecies(index) = 1;
            distinctValueIndecies(index+Rchange) = 1;
            index = index + Cinterval;
        end      
        distinctValueNodes = find(distinctValueIndecies);
% node = pp(bh);
% counter = 1;
%     while node<160000
%         distinctValueNodes(counter) = node;
%         counter = counter +1;
%         node = node + 625;
%     end
%         
    %% Lser for relevante noder    
        for ii = 1:length(distinctValueNodes)
            nn                      = distinctValueNodes(ii);
            
            capLeftVec              = nodeNetwork(nn,1:numProdHours);
            priceVec                = nodeNetwork(nn,1+numProdHours:2*numProdHours);
            runningVec              = nodeNetwork(nn,1+2*numProdHours:3*numProdHours);
            MC_vec_t                = nodeNetwork(nn,1+3*numProdHours:4*numProdHours);
            
            [maxValue optimalSolutionVec maxIndex]  = objValAndDecisions_CP(priceVec,capLeftVec,runningVec,nextStageExVals',CR_Matrix,C_ss,MC_vec_t,bh,nn,intervals(:,2),runBeforeDay,runAfterDay,maxCap);
            temp                                    = [maxValue optimalSolutionVec(10:17) maxIndex];
            
            saveObjValues(ii)   = temp(1);
            saveX_sell_Var1(ii) = temp(2);
            saveX_sell_Var2(ii) = temp(3);
            saveX_sell_Var3(ii) = temp(4);
            saveX_sell_Var4(ii) = temp(5);
            saveX_buy_Var1(ii)  = temp(6);
            saveX_buy_Var2(ii)  = temp(7);
            saveX_buy_Var3(ii)  = temp(8);
            saveX_buy_Var4(ii)  = temp(9);
            saveMaxIndex(ii)    = temp(10);            
        end %parfor 
        
    %% Lagrer decision variables og objective value i totNetwork
    
        for ii = 1:length(distinctValueNodes)
            
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(1))   = saveX_sell_Var1(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(2))   = saveX_sell_Var2(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(3))   = saveX_sell_Var3(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(4))   = saveX_sell_Var4(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(5))   = saveX_buy_Var1(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(6))   = saveX_buy_Var2(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(7))   = saveX_buy_Var3(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(8))   = saveX_buy_Var4(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+objValRow)       = saveObjValues(ii);
            totNetwork(distinctValueNodes(ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow)    = saveMaxIndex(ii); 
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(1))   = saveX_sell_Var1(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(2))   = saveX_sell_Var2(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(3))   = saveX_sell_Var3(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(4))   = saveX_sell_Var4(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(5))   = saveX_buy_Var1(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(6))   = saveX_buy_Var2(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(7))   = saveX_buy_Var3(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+decVarRows(8))   = saveX_buy_Var4(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+objValRow)       = saveObjValues(ii);
%             totNetwork((ii),numStateVar*numProdHours+(bh-1)*nextIndexRow+nextIndexRow)    = saveMaxIndex(ii);
        end
        
        %Lagrer tilsvarende rader med samme verdier (kun for pris =
        %simPris)
        dataColumns = numStateVar*numProdHours+(bh-1)*nextIndexRow+1:numStateVar*numProdHours+bh*nextIndexRow-1;
        maxIndexColumn = numStateVar*numProdHours+bh*nextIndexRow;
        for counter = 1:length(distinctValueNodes)
            valueIndex = distinctValueNodes(counter);
            index = valueIndex + repeats(4,1);
            if counter < length(distinctValueNodes)
                breakPoint = distinctValueNodes(counter+1);
            else
                breakPoint = numNodes+1;
            end
            counterCap = 0;
            while index < breakPoint
                totNetwork(index,dataColumns) = totNetwork(valueIndex,dataColumns);
                counterCap = counterCap+1;
                totNetwork(index,maxIndexColumn) = totNetwork(valueIndex,maxIndexColumn)+counterCap;
                index = index + repeats(4,1);
            end
        end
        
        
    %% Setter future value for deterministisk DP
    
        nextStageExVals = nan(numNodes/numPcomb,1);
        objVal_column           = numStateVar*numProdHours+(bh-1)*nextIndexRow+objValRow;
        for nn = 1:numCcomb       
            totNetwork_row          = (nn-1)*numPcomb+pp(bh);
            nextStageExVals(nn)     = totNetwork(totNetwork_row,objVal_column);       %Size = 256x1
        end  
        
    end  %for  
    %% Lagrer mlfunksjonsverdier for initielle kapasiteter og deterministic policy
    deterministicObjective  = nextStageExVals;
    deterministicPolicy     = totNetwork;
end %function