function [nodeMatrix, C_R_Matrix, sortData,CapSet, maxCap, priceVec, indekser, priceMatrix,combinationCapLeft,waterValuePerCubic]= createNodeMatrix_CP(WaterValue,head,dateStr,SRMC,EURtoNOK)
% [nodeMatrix C_R_Matrix] = createNodeMatrix(28,275,{[2018,3,20,12,00,00]},30)
%SRMC: 20-40-sjiktet
%WV: 0-50 sjiktet, snitt 28
%% On new days the model must be run. This function returns the correct C__R_Matrix and also nodeMatrix, only the CR-matrix differs dep. on input 
%WaterValue                              = 30;
%head                                    = 275;     
% priceFormat = 'state' or 'price'
%% SoeaG1Global.m and MCSoeaG1Global.m related input
     Qnett = 0;         %: Reaktiv effekt som brukes i funksjonen.    
     MohU  = -1;        %: Undervann utlp av Sa-kraftverk, det vil si til sjen.
     UtType = 'Pnett';  %: Angir hvilken data brukeren vil ha, se funksjon for forklaring.
%% Generation of all vectors in nodes
     %tic
%    if strcmp(priceFormat,'price')
%% Price combinations: state as basis for buy and sell prices.
        load('meanPriceInLevel_Master.mat'); %load middle points in states.
        priceVec                        = meanPriceInLevel;
        sets                            = {priceVec,priceVec,priceVec,priceVec};
       % sets                            = {[0.0583 0.2440 0.5263 0.7369 0.9354], [0.0583 0.2440 0.5263 0.7369 0.9354], [0.0583 0.2440 0.5263 0.7369 0.9354], [0.0583 0.2440 0.5263 0.7369 0.9354]};
        [p1, p2, p3, p4]                = ndgrid(sets{:});
        combinationPrices               = [p1(:) p2(:) p3(:) p4(:)]; 
% Prices are set to avg. of the state. Then de-PIT, detrend and denormalize.        
        priceMatrix                     = stateMatrixToPrices(combinationPrices,dateStr,SRMC);
%    else % priceFormat == 'state'
%% Price combinations: state as basis for buy and sell prices.
%        sets                            = {[1 2 3 4 5], [1 2 3 4 5], [1 2 3 4 5],[1 2 3 4 5]};
%        [p1 p2 p3 p4]                   = ndgrid(sets{:});
%        combinationPrices               = [p1(:) p2(:) p3(:) p4(:)]; 
%    end
%% Running status combinations
    runningVec = zeros(1,4);
%     sets                            = {[0 1],[0 1],[0 1],[0 1]};
%     [delta1 delta2 delta3 delta4]   = ndgrid(sets{:});
%     combinationRunningStatus        = [delta1(:) delta2(:) delta3(:) delta4(:)];
%% Capacity left combinations
    [CapSet, maxCap]                = makeCapLevels(Qnett,head,MohU,UtType);
    sets                            = {CapSet,CapSet,CapSet,CapSet};%{[4.5,13.5,22.5,31.5],[4.5,13.5,22.5,31.5],[4.5,13.5,22.5,31.5],[4.5,13.5,22.5,31.5]};
    [cap1, cap2, cap3, cap4]        = ndgrid(sets{:});
    combinationCapLeft              = [cap1(:) cap2(:) cap3(:) cap4(:)];
%% Finner vannverdi/m^3 for gitt vannstand
Bestpunkt = BestpunktSoea(head,Qnett,MohU);
QBestpunkt = Bestpunkt(1);
PBestpunkt = Bestpunkt(2);
waterValuePerCubic      = PBestpunkt*WaterValue/QBestpunkt;
%% Generate Nodes
    nodeNum                         = 1;
%% Create node matrix
    nodeMatrix                      = zeros(5^4*4^4,17); % matrisen for ett steg. 4 kolonner per tilstand = 1 rad med 12 kolonner per node. + 4 kolonner med MC_vec. + 1 kollonne for 1/0 for gyldig/ikke gyldig.  
%% Oppretter cap-run vector.        
    cr_nCols                        = 12; % 4xcap,4xrun,MC
    C_R_Matrix                      = zeros(4^4,cr_nCols); 
    CR_combo_num                    = 1;
%% Loop through all combinations of vectors. Get 2,650,000 nodes.
% NodeMatrix fr strukturen: [cccc rrrr pppp ... ] for  ha bolker p 625
% rader med alle priese representert.
        for capLeftVectorsRow = 1:size(combinationCapLeft,1) 
            % kun 4 mulige inputs og outputs:
                capVec      = combinationCapLeft(capLeftVectorsRow,:);
                prodVec     = maxCap - capVec;
                [MC1, AC1]  = MCSoeaG1Global(prodVec(1),WaterValue,waterValuePerCubic,Qnett,head,MohU,UtType,EURtoNOK,'EUR/MWh');
                [MC2, AC2]  = MCSoeaG1Global(prodVec(2),WaterValue,waterValuePerCubic,Qnett,head,MohU,UtType,EURtoNOK,'EUR/MWh');
                [MC3, AC3]  = MCSoeaG1Global(prodVec(3),WaterValue,waterValuePerCubic,Qnett,head,MohU,UtType,EURtoNOK,'EUR/MWh');
                [MC4, AC4]  = MCSoeaG1Global(prodVec(4),WaterValue,waterValuePerCubic,Qnett,head,MohU,UtType,EURtoNOK,'EUR/MWh');
                AC_Vec      = [AC1,AC2,AC3,AC4];
                
                for ii = 1:length(capVec)
                    if capVec(ii) ~= CapSet(4)
                        runningVec(ii) = 1;
                    else
                        runningVec(ii) = 0;
                    end
                end
            %for runningStatusVectorsRow = 1:size(combinationRunningStatus,1) 
                for priceVectorsRow = 1:size(priceMatrix,1)
                    nodeMatrix(nodeNum,1:4)       = combinationCapLeft(capLeftVectorsRow,:);                    
                    nodeMatrix(nodeNum,5:8)       = priceMatrix(priceVectorsRow,:);
                    nodeMatrix(nodeNum,9:12)      = runningVec;
                    nodeMatrix(nodeNum,13:16)     = AC_Vec;
                    nodeMatrix(nodeNum,17)        = 0;
                    
%                     for i = 1:length(combinationRunningStatus(runningStatusVectorsRow,:))
%                         if ((combinationRunningStatus(runningStatusVectorsRow,i) == 0) && (combinationCapLeft(capLeftVectorsRow,i) ~= cap1(4)) || (combinationRunningStatus(runningStatusVectorsRow,i) == 1) && (combinationCapLeft(capLeftVectorsRow,i) == cap1(4)))
%                             nodeMatrix(nodeNum,13)  = 0;
%                             break;
%                         end
%                     end

                    nodeNum                            = nodeNum + 1;
                end                
                
                C_R_Matrix(CR_combo_num,1:4)           = capVec;                    
                C_R_Matrix(CR_combo_num,5:8)           = runningVec;
                C_R_Matrix(CR_combo_num,9:12)          = AC_Vec;
%                 C_R_Matrix(CR_combo_num,cr_nCols)      = 1;
%                 for i = 1:length(combinationRunningStatus(runningStatusVectorsRow,:))
%                     if ((combinationRunningStatus(runningStatusVectorsRow,i) == 0) && (combinationCapLeft(capLeftVectorsRow,i) ~= cap1(4)) || (combinationRunningStatus(runningStatusVectorsRow,i) == 1) && (combinationCapLeft(capLeftVectorsRow,i) == cap1(4)))
%                         C_R_Matrix(CR_combo_num,9)   = 0;
%                         break;
%                     end
%                 end

                CR_combo_num                            = CR_combo_num + 1;
            %end  
        end

%% Valid rows in nodeMatrix and C_R_Matrix
% valid_nodeMatrix    = find(nodeMatrix(:,13));
% valid_C_R_Matrix    = find(C_R_Matrix(:,cr_nCols));

% %% Skriv til fil for testing
% [fid msg] = fopen('testFile','w');
%     if (fid > -1)
%         numElemSaved = fwrite(fid,nodeMatrix,'double');
%         if numElemSaved 
%             disp('Elementene er lagret');
%         else 
%             disp('Noe kan ha gtt galt under lagring');
%         end
%     else
%         output = 0
%         disp(msg);
%     end
%     status = fclose(fid)

%% Determine pattern of occurances in nodeMatrix and C_R_Matrix
    numPriceCombos          = size(combinationPrices,1);
    numPriceLevels          = sqrt(sqrt(size(combinationPrices,1)));
    
    numPH                   = size(combinationPrices,2);
    
    pStart                  = NaN(1,numPH);
    pIntervals              = NaN(1,numPH);
    pRepeat                 = NaN(1,numPH);
    
    cStart                  = NaN(1,numPH);
    cIntervals              = NaN(1,numPH);
    cRepeat                 = NaN(1,numPH);
    
    rStart                  = NaN(1,numPH);
    rIntervals              = NaN(1,numPH);
    rRepeat                 = NaN(1,numPH);
    
    
    for ph = 1:numPH
        pStart(ph)          = 1;
        pIntervals(ph)      = numPriceLevels^(ph-1);
        pRepeat(ph)         = numPriceLevels^ph;
        
        cStart(ph)          = 1;
        cIntervals(ph)      = numPriceCombos*numPH^(ph-1);
        cRepeat(ph)         = numPriceCombos*numPH^ph;
        
        rStart(ph)          = cRepeat(ph)-cIntervals(ph);
        rIntervals(ph)      = cIntervals(ph);
        rRepeat(ph)         = cRepeat(ph);
    end
    
    starts = [pStart; cStart; rStart]';
    intervals = [pIntervals; cIntervals; rIntervals;]';
    repeats = [pRepeat; cRepeat; rRepeat;]';
    
    sortData = [starts intervals repeats];
    
%% Save distinctValue indecies for each bid hour

indekser = zeros(length(nodeMatrix),6);

for bh = 6:-1:4
    next_ph = bh -2;
    if next_ph > 0
        index = 1;
        %Finner unike C-kombos
        while index < length(indekser)
            
            indekser(index,bh) = 1;                             %ph-1 kjrer
            indekser(index+starts(next_ph-1,3),bh) = 1;         %ph-1 kjrer ikke

            index2 = index;
            
            %Finner unike P-combos
            while index2 - index < repeats(4,1)
                
                indekser(index2,bh) = 1;                        %ph-1 kjrer
                indekser(index2+starts(next_ph-1,3),bh) = 1;    %ph-1 kjrer ikke:

                index2 = index2 + intervals(next_ph,1);
            end
            index = index + intervals(next_ph,2);
        end
    end
end
%toc   
end