function [accumCapCorr,accumRunCorr_init,accumStateCapCorr,accumSpotCommitment,capCorr,runCorr_init,stateCapCorr,spotCommitment,spotPrices,waterValue,fullCaseDatoVec,head,EURtoNOK] = evaluateInstances()
clear all;
startDayStr         = {'2-Jan-2013'};
endDayStr           = {'29-Sep-2017'};
%% Parametre
accumHours                  = 6;
hrInDay                     = 24;
nProd_model                 = 4;
simProdHr                   = 24;
simBidHrTot                 = 34;
% load('smallP_AvgMasterForSimulation.mat'); % P - for simulation
load('levelLimits_simulationModel.mat'); %levelLimits
load('meanPriceInLevelSimHrByHr.mat')  % meanPriceInLevel
load('upperPrizeStateLimit_6by6Hr_model.mat'); %grenseVerdierUpper. Gjelder 6x6 prismodell. M n plassere virkelige priser inn som en ville gjort ved bruk.
% P=P;
levelLimits=levelLimits;
meanPriceInLevel=meanPriceInLevel;
grenseVerdierUpper=grenseVerdierUpper;
% Load all input parameters:
%load('VVDato.mat'); % GIVES SOME STRANGE VALUES IN THE MIDDLE...
dateVec             = 735235:1:7370760; % datenums coresponding to data set. Also given in vector, but some values deviate from whole numbers and are cumbersome to use.
dateVec             = dateVec';
load('VV_Soea.mat');
vvVec               = VV_Soea;
load('DataTabell.mat');
dataTabellTab       = DataTabell;
headVec             = dataTabellTab.('Vannstand_Vassli');
spotPriceVec        = dataTabellTab.('SpotPris');
spotCommitmentVec   = dataTabellTab.('Anmeldt'); % Commited PRODUCTION.
datoVec             = dataTabellTab.('Dato');

load('SRMC_Vec.mat');
SRMCVec             = srmcVec;
load('ICCEURNOKDAG.mat');
EURNOKVec           = ICCEURNOKDAG;

%% Get input data for period from files
% Ulike input data for ulike dager.
startDateNum        = datenum(startDayStr);
endDateNum          = datenum(endDayStr);
nDays               = endDateNum-startDateNum+1;
%% Eurtonok og SRMC inneholder mye nan. Sett inn kode som bytter ut nan med
%verdiene foran...
temp = SRMCVec(1);          %First value is defined
temp2 = EURNOKVec(2);       %First value is NOT defined
for day = 1:length(SRMCVec) % assuming first value is not NaN.
    if ~isnan(SRMCVec(day)) %&& hour <=lastCapData
        temp = SRMCVec(day);
    else
        SRMCVec(day) = temp;
    end
    if ~isnan(EURNOKVec(day)) %&& hour <=lastCapData
        temp2 = EURNOKVec(day);
    else
        EURNOKVec(day) = temp2;
    end
end


%% Aggregert case
% Hour data accumulated to hour avg. of blocks:
% Number of hours in block. Can change:
Time_blocks             = hrInDay/accumHours;
accumLength             = floor(length(headVec)/hrInDay);
% Make the vector length possible to split in blocks of 'accumHours' hours.
cutOut                  = mod(accumLength,accumHours);
accumLength             = accumLength - cutOut;
accumHeadVecBlock       = zeros(accumLength,Time_blocks);
accumHeadVec            = zeros(accumLength,1);
accumSpotPriceVec       = zeros(accumLength,Time_blocks);

accumSpotCommitmentVec  = zeros(accumLength,Time_blocks);

for day = 1:(accumLength-12)
    firstElemInDayIdx                       = (day-1)*hrInDay+1; % 1, 25, 49 etc. ...
    for block = 1:(Time_blocks)
        firstBlockHr                        = firstElemInDayIdx + (block-1)*accumHours;
        lastBlockHr                         = firstBlockHr+accumHours-1;
        accumSpotPriceVec(day,block)        = nanmean(spotPriceVec(firstBlockHr:lastBlockHr)); % vector
        accumSpotCommitmentVec(day,block)   = nanmean(spotCommitmentVec(firstBlockHr:lastBlockHr)); %vector.
        accumHeadVecBlock(day,block)        = nanmean(headVec(firstBlockHr:lastBlockHr));
    end
    % Creating new vectors with mean values over blocks of "accumHours" number of hours.
    accumHeadVec(day)                       = nanmean(accumHeadVecBlock(day,:));
end
% Make matrix with daily information:
infoMatrix              = zeros(accumLength,13); % dato,VV,Head,SRMC,EURtoNOK, spot

infoMatrix(:,1)         = dateVec(1:accumLength);
infoMatrix(:,2)         = vvVec(1:accumLength);
infoMatrix(:,3)         = accumHeadVec;
infoMatrix(:,4)         = SRMCVec(1:accumLength);
infoMatrix(:,5)         = EURNOKVec(1:accumLength);
infoMatrix(:,6:9)       = accumSpotPriceVec;
infoMatrix(:,10:13)     = accumSpotCommitmentVec;
accumCapCorr                 = zeros(nDays,6);
accumRunCorr_init            = zeros(nDays,6);
accumStateCapCorr            = zeros(nDays,6);
% Get contingency plan for the given day by running the DP for given inputs.
idx                     = find(dateVec == startDateNum);
idxStop                 = find(dateVec == endDateNum);

for day = 1:nDays
    %get info
    dateNumber                      = infoMatrix(idx+day-1,1);
    waterValue(day)                      = infoMatrix(idx+day-1,2);
    head                            = infoMatrix(idx+day-1,3);
    accumSpotCommitment(day,1:4)                  = infoMatrix(idx+day-1,10:13);
    accumPrices(day,1:4)                = infoMatrix(idx+day-1,6:9);
    
    if (idx == 1 && day == 1)
        spotCommitmentLastBlockDayBefore = 0;
    else
        spotCommitmentLastBlockDayBefore = infoMatrix(idx+day-2,13);
    end
    spotCommitmentNextBlockDayAfter = infoMatrix(idx+day,10);

    commitmentInSpotVec             = [spotCommitmentLastBlockDayBefore accumSpotCommitment(day,:) spotCommitmentNextBlockDayAfter];
    
    %% SoeaG1Global.m and MCSoeaG1Global.m related input
    Qnett = 0;         %: Reaktiv effekt som brukes i funksjonen.
    MohU  = -1;        %: Undervann utlp av Sa-kraftverk, det vil si til sjen.
    UtType = 'Pnett';  %: Angir hvilken data brukeren vil ha, se funksjon for forklaring.
    [CapSet, maxCap]                = makeCapLevels(Qnett,head,MohU,UtType);
    
    capLeftInitialVec       = maxCap - commitmentInSpotVec; % calculate capLeft before rounding to nearest capLeft level.
    diffMatrix              = zeros(length(commitmentInSpotVec),length(CapSet));
    
    % Round to nearest capLeft level
    for commitmentElements = 1:length(capLeftInitialVec)
        for comparisonElementInCapSet =1:length(CapSet)
            diffMatrix(commitmentElements,comparisonElementInCapSet)     = abs(CapSet(comparisonElementInCapSet)-capLeftInitialVec(commitmentElements));
        end
        [~,idxCorr]                                    = min(diffMatrix(commitmentElements,:));
        % capCorr is the vector that describes the capLeft status to compare with nodes in the DP.
        accumCapCorr(day,commitmentElements)                    = CapSet(idxCorr);
        accumStateCapCorr(day,commitmentElements) = idxCorr;
        if accumCapCorr(day,commitmentElements) == max(CapSet)
            accumRunCorr_init(day,commitmentElements) = 0;
        else
            accumRunCorr_init(day,commitmentElements) = 1;
        end
    end
end

%% Fullt case
%spotCommitmentVec
idx                     = find(dateVec == startDateNum);
capCorr                 = zeros(nDays,26);
runCorr_init            = zeros(nDays,26);
stateCapCorr            = zeros(nDays,26);

for day = 1:nDays
    rows = (idx+day-2)*24+1:(idx+day-1)*24;
    spotCommitment(day,1:length(rows)) = spotCommitmentVec(rows);
    EURtoNOK(day) = EURNOKVec(idx+day-1);
    %fullCaseDatoVec(day) = dateVec(idx+day-1);
    if (idx == 1 && day == 1)
        preCommitment = 0;
    else
        preCommitment = spotCommitmentVec((idx+day-2)*24);
    end
    if day+idx+11 >= length(dateVec)
        postCommitment = 0;
    else
        postCommitment = spotCommitmentVec((idx+day-1)*24);
    end
    fullCommitment = [preCommitment spotCommitment(day,:) postCommitment]';
    
    head(day)                            = infoMatrix(idx+day-1,3);
    
    Qnett = 0;         %: Reaktiv effekt som brukes i funksjonen.
    MohU  = -1;        %: Undervann utlp av Sa-kraftverk, det vil si til sjen.
    UtType = 'Pnett';  %: Angir hvilken data brukeren vil ha, se funksjon for forklaring.
    [CapSet, maxCap]                = makeCapLevels(Qnett,head(day),MohU,UtType);
    
    capLeftInitialVec       = maxCap - fullCommitment; % calculate capLeft before rounding to nearest capLeft level.
    diffMatrix              = zeros(length(fullCommitment),length(CapSet));
    
    % Round to nearest capLeft level
    for commitmentElements = 1:length(capLeftInitialVec)
        for comparisonElementInCapSet =1:length(CapSet)
            diffMatrix(commitmentElements,comparisonElementInCapSet)     = abs(CapSet(comparisonElementInCapSet)-capLeftInitialVec(commitmentElements));
        end
        [~,idxCorr]                                    = min(diffMatrix(commitmentElements,:));
        % capCorr is the vector that describes the capLeft status to compare with nodes in the DP.
        capCorr(day,commitmentElements)                    = CapSet(idxCorr);
        stateCapCorr(day,commitmentElements) = idxCorr;
        if capCorr(day,commitmentElements) == max(CapSet)
            runCorr_init(day,commitmentElements) = 0;
        else
            runCorr_init(day,commitmentElements) = 1;
        end
    end
end
spotPrices = spotPriceVec((idx-1)*24+1:idxStop*24-1);
fullCaseDatoVec = datoVec((idx-1)*24+1:idxStop*24-1);

end