clear all
[accumCapCorr,accumRunCorr_init,accumStateCapCorr,accumSpotCommitment,capCorr,runCorr_init,stateCapCorr,spotCommitment,spotPrices,waterValue,fullCaseDatoVec,head,EURtoNOK] = evaluateInstances();
waterV = repmat(waterValue(1),1,24);
spotProd = spotCommitment(1,:);
%% Setter sammen data time for time
for i = 2:length(spotCommitment)
    spotProd = [spotProd spotCommitment(i,:)];
    b = repmat(waterValue(i),1,24);
    waterV = [waterV b];
end
spotProd = spotProd';
spotProd = spotProd(1:end-1);
waterV = waterV';
waterV = waterV(1:end-1);
dataTotHour = [fullCaseDatoVec spotProd spotPrices waterV];

%% Setter sammen data dag for dag (gjsnitt pris, prod=nan)
dataTotDay = nan(length(waterValue)-1,6);
dateNum = dataTotHour(1,1);
for i = 1:length(waterValue)-1
    startRow = find(ismember(dataTotHour(:,1),dateNum));
    endRow = find(ismember(dataTotHour(:,1),dateNum+1));
    if endRow -startRow ~=24
        timeOfChange = dateNum;
    end
    rows = startRow:endRow-1;
    spotDayAvg(i) = sum(dataTotHour(rows,3))/24;
    dataTotDay(i,1) = dataTotHour(rows(1),1);
    dataTotDay(i,3) = spotDayAvg(i);
    dataTotDay(i,4) = dataTotHour(rows(1),4);
    dateNum = dateNum + 1;
end
%% Finner inntekt fra spot commitment
days = ["17-May-2017" "18-May-2017" "25-May-2017" "26-May-2017" "02-Jun-2017" "05-Jun-2017" "10-Jun-2017" "14-Jun-2017" "17-Jun-2017" "21-Jun-2017" "22-Jun-2017" "25-Jun-2017" "27-Jun-2017" "28-Jun-2017" "10-Jul-2017" "13-Jul-2017" "16-Jul-2017" "18-Jul-2017" "20-Jul-2017" "26-Jul-2017" "31-Jul-2017"];
Qnett = 0;
UtType = 'Pnett';
MohU = -1;

revenuesSpot = dataTotHour(:,2).*dataTotHour(:,3);
costsSpot = zeros(length(revenuesSpot),1);
for d = 1:length(days)
    day = char(days(d));
    idx = find(ismember(dataTotHour(:,1),datenum(day)));
    idxday = floor(idx/24);
    for i = 1:24
        costsSpot(idx) = MCSoeaG1Global(dataTotHour(idx,2),dataTotHour(idx,4),Qnett,head(idxday),MohU,UtType,EURtoNOK(idxday),'EUR/MWh');
        revenuesSpot(idx,2) = 1;
        idx = idx+1;
    end
end
idxes = find(costsSpot);
costMat = [costsSpot(idxes) dataTotHour(idxes,2) dataTotHour(idxes,3)];
costsSpot = dataTotHour(:,2).*costsSpot(:);
totRev = sum(revenuesSpot(:,1).*revenuesSpot(:,2));
totMC = sum(costsSpot(~isinf(costsSpot)));
totPremium = totRev-totMC;
%% Setter sammen produksjonsdata bolk for bolk
dataProdBolk = [dataTotDay(:,1) accumSpotCommitment(1:length(waterValue)-1,:)];
dataRunBolk = [dataTotDay(:,1) accumRunCorr_init(1:length(waterValue)-1,1:6)];
%% Finner gjennomsnittlig spot og vannverdi (for testing)
avgWaterV = sum(waterV)/length(waterV);
avgSpotPrice = sum(spotPrices(1:length(waterV)))/length(waterV);
%% Finner sortert delta p spot og vannverdi
%Per time
dataTotHour(:,5) = dataTotHour(:,3)-dataTotHour(:,4);
sortDeltaHour = sort(dataTotHour(:,5));
%Per dag
dataTotDay(:,5) = dataTotDay(:,3)-dataTotDay(:,4);
sortDeltaDay = sort(dataTotDay(:,5));
%% Plotter vannverdi og spot
% figSpotVann = figure;
% plot(dataTotHour(:,3:4));
% legend('Spot prices (hourly)', 'Water values (daily)')
% xlabel('Hours in the data set (01.01.2013-30.09.2017)');
% ylabel('Euro');
%% Finner cutt-off verdier for analyse
numDays = length(waterValue)-1;
numCategories = 3;
numElemInCategories = round(numDays/numCategories);
ekstraElems = numDays-numElemInCategories*numCategories;
newDeltaSet = sortDeltaDay(1+ekstraElems:numDays);
dataSet = nan(numElemInCategories,numCategories);
for category = 1:numCategories
    dataRows = (category-1)*numElemInCategories+1:category*numElemInCategories;
    dataSet(:,category) = newDeltaSet(dataRows); 
    a(category) = dataRows(1);
    b(category) = dataRows(end);
    if category == 1
        c(category) = a(category);
    else
        c(category) = b(category);
    end
    vektPunkt(category) = (a(category)+b(category)+c(category))/3; %Gir indeks i dataSet (dag)
    deltaVektPunkt(category) = dataSet(vektPunkt(category)); %Gir delta i dataset 
    maxDelta(category) = dataSet(end,category);
    minDelta(category) = dataSet(1,category);
end
vekter = [vektPunkt;deltaVektPunkt;maxDelta;minDelta];
%% Plotter vannverdi, spot og deltagreier
deltaFigs = figure;
subplot(1,2,2);
plot(1:length(sortDeltaDay),dataTotDay(:,5),1:length(sortDeltaDay), newDeltaSet);
title('Difference in daily average spot prices and water value')
legend('As a function of time','Sorted in increasing order')
xlabel('Days in the data set');
ylabel('Euros')
xlim([1 1732])
subplot(1,2,1);
plot(dataTotHour(:,3:4));
title('Spot prices and water values in the data set');
legend('Spot prices (hourly)', 'Water values (daily)')
xlabel('Hours in the data set');
ylabel('Euros');
xlim([1 41657])

deltaFigsCloseup = figure;
subplot(1,2,2);
plot(1:length(sortDeltaDay),dataTotDay(:,5),1:length(sortDeltaDay), newDeltaSet);
title('Difference in daily average spot prices and water value')
legend('As a function of time','Sorted in increasing order')
xlabel('Days in the data set');
ylabel('Euros')
xlim([1 1732])
ylim([-20 100]);
subplot(1,2,1);
plot(dataTotHour(:,3:4));
title('Spot prices and water values in the data set');
legend('Spot prices (hourly)','Water values (daily)')
xlabel('Hours in the data set');
ylabel('Euros');
xlim([1 41657])
ylim([-20 100]);
%% Finner breakoff-verdier for hvilke delta som tilhrer hver deltakategori
for i = 1:numCategories-1
    breakOff(i) = (minDelta(i+1)+maxDelta(i))/2;
end
%% Finner indekser i datasettet som tilhrer hver deltakategori
for i = 1:numDays
    dataTotDay(i,6) = 1;
    for j = 1:length(breakOff)
        if dataTotDay(i,5) > breakOff(j)
            dataTotDay(i,6) = j+1;
        end
    end
end
idxInCategory = nan(numElemInCategories,numCategories);
for c = 1:numCategories
    idxInCategory(:,c) = find(ismember(dataTotDay(:,6),c));
end
%% Sjekker kjreplanen i datasettet og angir 1-64
    sets                            = {[0 1],[0 1],[0 1],[0 1],[0 1],[0 1]};
    [delta1 delta2 delta3 delta4 delta5 delta6]   = ndgrid(sets{:});
    combinationRunningStatus        = [delta1(:) delta2(:) delta3(:) delta4(:) delta5(:) delta6(:)];
for i=1:numDays
    dataRunBolk(i,8) = find(ismember(combinationRunningStatus,dataRunBolk(i,2:7),'rows'));
end
%% Finner totalt antall dager som har hver kjreplan
antRun = nan(64,1);
for r = 1:64
    antRun(r) = sum(ismember(dataRunBolk(:,8),r));
end

%% Finner antall dager som har de ulike kombinasjonene av delta og running
runInCategory = nan(numElemInCategories,numCategories);
for c = 1:numCategories
    runInCategory(:,c) = dataRunBolk(idxInCategory(:,c),8);
    sortRunInCategory(:,c) = sort(runInCategory(:,c));
    for r = 1:length(combinationRunningStatus)
        numOfRunOccurances(r,c) = sum(ismember(runInCategory(:,c),r));
    end
end
%% Plotter antall for kombi(delta,run)
figDeltaRunAnt = figure;
subplot(2,1,1)
bar(antRun);
title('Number of days in the data set with each initial unit commitment');
xlabel('Unit Commitment');
ylabel('Number of days');
xlim([0,65]);
subplot(2,1,2)
b = bar(1:64,numOfRunOccurances);
b(3).FaceColor = [0.6 0 0.5];
title('Number of intersects of each delta and unit commitment in the data set');
xlabel('Unit Commitment');
ylabel('Number of days');
legend('Delta: -193,255-0,323','Delta: 0,324-4,189','Delta: 4,200-66,103');
xlim([0,65]);
%% Finner data for 2017
startdateStr = '1-Jan-2017';
startDateNum = datenum(startdateStr);
startIdxDay2017 = find(ismember(dataTotDay(:,1),startDateNum));
startIdxHour2017 = find(ismember(dataTotHour(:,1),startDateNum));
endIdxDay2017 = length(dataTotDay);
endIdxHour2017 = length(dataTotHour);
rows2017 = startIdxDay2017:endIdxDay2017;

dataTotDay2017 = dataTotDay(startIdxDay2017:endIdxDay2017,:);
dataTotHour2017 = dataTotHour(startIdxHour2017:endIdxHour2017,:);
%% Finner indekser for data i 2017 som inngr i de ulike kategoriene for Run og Delta
idxRunDelta = zeros(length(rows2017),length(combinationRunningStatus),numCategories);
for c = 1:numCategories
    idx1 = find(ismember(dataTotDay(rows2017,6),c));
    idx1 = idx1 + startIdxDay2017-1;
    for r = 1:length(combinationRunningStatus)
        idx2 = find(ismember(dataRunBolk(rows2017,8),r));
        idx2 = idx2 + startIdxDay2017-1;
        keepidx2(r) = sum(ismember(dataRunBolk(rows2017,8),r));
        idx3 = intersect(idx1,idx2);
        idxRunDelta(1:length(idx3),r,c) = idx3;
        dateNameRunDelta(1:length(idx3),r,c) = cellstr(datestr(dataTotDay(idx3,1)));
    end
end
idxRunDeltaSelected = [idxRunDelta(:,1,:) idxRunDelta(:,30,:) idxRunDelta(:,64,:)];
nameRunDeltaSelected = [dateNameRunDelta(:,1,:) dateNameRunDelta(:,30,:) dateNameRunDelta(:,64,:)];


