%% TESTING
% Pick a testing period. Initial date and duration.
function [UB_matrix,LB_matrix] = findBounds(dayStr,nSimulations)
% Typical input: [UB_matrix,LB_matrix] =
% findBounds({'12-May-2014'},{'12-May-2014'},5,0)
%startDayStr         = {'1-May-2013'};
%endDayStr           = {'19-May-2013'};
tic
    accumHours                  = 6;
    hrInDay                     = 24;
    nProd_model                 = 4;
    simProdHr                   = 24;
    simBidHrTot                 = 34;
    load('smallP_AvgMasterForSimulation.mat'); % P - for simulation
    load('levelLimits_simulationModel.mat'); %levelLimits
    load('meanPriceInLevelSimHrByHr.mat')  % meanPriceInLevel   
    load('upperPrizeStateLimit_6by6Hr_model.mat'); %grenseVerdierUpper. Gjelder 6x6 prismodell. M n plassere virkelige priser inn som en ville gjort ved bruk.   
    P=P;
    levelLimits=levelLimits;
    meanPriceInLevel=meanPriceInLevel;
    grenseVerdierUpper=grenseVerdierUpper;
    % Load all input parameters:
%load('VVDato.mat'); % GIVES SOME STRANGE VALUES IN THE MIDDLE...
    dateVec             = 735235:1:7370760; % datenums coresponding to data set. Also given in vector, but some values deviate from whole numbers and are cumbersome to use.
    dateVec             = dateVec';
    load('VV_Soea.mat');
    vvVec               = VV_Soea;
    load('DataTabell.mat');
    dataTabellTab       = DataTabell;
    headVec             = dataTabellTab.('Vannstand_Vassli');
    spotPriceVec        = dataTabellTab.('SpotPris');
    spotCommitmentVec   = dataTabellTab.('Anmeldt'); % Commited PRODUCTION.
    load('SRMC_Vec.mat');
    SRMCVec             = srmcVec;
    load('ICCEURNOKDAG.mat');
    EURNOKVec           = ICCEURNOKDAG;
    % for the simulation purpose, there are some non-accumulated prices
    % associated to each day. Get these from stateTable.
    load('stateTableAvg_notAccum.mat') % stateTable out
%% Get input data for period from files
% Ulike input data for ulike dager.
    startDayStr         = dayStr;
    endDayStr           = dayStr;
    startDateNum        = datenum(startDayStr);
    endDateNum          = datenum(endDayStr);
    nDays               = endDateNum-startDateNum+1;
%% Eurtonok og SRMC inneholder mye nan. Sett inn kode som bytter ut nan med
%verdiene foran...
    temp = SRMCVec(1);          %First value is defined
    temp2 = EURNOKVec(2);       %First value is NOT defined
    for day = 1:length(SRMCVec) % assuming first value is not NaN.
         if ~isnan(SRMCVec(day)) %&& hour <=lastCapData
            temp = SRMCVec(day);
         else
            SRMCVec(day) = temp;
         end 
         if ~isnan(EURNOKVec(day)) %&& hour <=lastCapData
            temp2 = EURNOKVec(day);
         else
            EURNOKVec(day) = temp2;
         end 
    end
% Hour data accumulated to hour avg. of blocks:
% Number of hours in block. Can change: 
    Time_blocks             = hrInDay/accumHours;
    accumLength             = floor(length(headVec)/hrInDay);
% Make the vector length possible to split in blocks of 'accumHours' hours.
    cutOut                  = mod(accumLength,accumHours);
    accumLength             = accumLength - cutOut;
    accumHeadVecBlock       = zeros(accumLength,Time_blocks);
    accumHeadVec            = zeros(accumLength,1);
    accumSpotPriceVec       = zeros(accumLength,Time_blocks);
    
    accumSpotCommitmentVec  = zeros(accumLength,Time_blocks);
% create a matrix of 24 daily spor prices that are utilized for simulation
    spotPriceStateMatrix         = zeros(size(stateTable,1)/hrInDay,hrInDay);
    spotPriceMatrix_notStates    = zeros(size(stateTable,1)/hrInDay,hrInDay);
    
    for day = 1:(accumLength-12)
        firstElemInDayIdx                       = (day-1)*hrInDay+1; % 1, 25, 49 etc. ...
        if (day < (size(stateTable,1)/hrInDay)-24) % nok data til 1703 dager
            spotPriceStateMatrix(day,:)             = table2array(stateTable(firstElemInDayIdx:firstElemInDayIdx+23,'StateAvg')); % States! Obs: andre states enn i  modell! Sammenlign priser! Hent 24 elementer per dag og legg i matrise.
            spotPriceMatrix_notStates(day,:)        = table2array(stateTable(firstElemInDayIdx:firstElemInDayIdx+23,'NormTrendPIT'));
        end
        for block = 1:(Time_blocks)   
            firstBlockHr                        = firstElemInDayIdx + (block-1)*accumHours;
            lastBlockHr                         = firstBlockHr+accumHours-1;
            accumSpotPriceVec(day,block)        = nanmean(spotPriceVec(firstBlockHr:lastBlockHr)); % vector
            accumSpotCommitmentVec(day,block)   = nanmean(spotCommitmentVec(firstBlockHr:lastBlockHr)); %vector. 
            accumHeadVecBlock(day,block)        = nanmean(headVec(firstBlockHr:lastBlockHr));
        end        
% Creating new vectors with mean values over blocks of "accumHours" number of hours.
        accumHeadVec(day)                       = nanmean(accumHeadVecBlock(day,:));
    end
% Make matrix with daily information:
    infoMatrix              = zeros(accumLength,13); % dato,VV,Head,SRMC,EURtoNOK, spot

    infoMatrix(:,1)         = dateVec(1:accumLength);
    infoMatrix(:,2)         = vvVec(1:accumLength);
    infoMatrix(:,3)         = accumHeadVec;
    infoMatrix(:,4)         = SRMCVec(1:accumLength);
    infoMatrix(:,5)         = EURNOKVec(1:accumLength);
    infoMatrix(:,6:9)       = accumSpotPriceVec;
    infoMatrix(:,10:13)     = accumSpotCommitmentVec;
% Get contingency plan for the given day by running the DP for given inputs.
    idx                     = find(dateVec == startDateNum);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % nSimulations            = 1; % 50 000
    LB_matrix               = zeros(nSimulations,nDays);
    UB_matrix               = zeros(nSimulations,nDays);
    disp('Getting data:');
    toc
    
%% Starter parallel parpool
    tic 
    parpool(30);
    toc

%% Solve for a period of days. Create multiple contingency plans.
    for day = 1:nDays 
    tic
        %Save files purpose
        dayToSave                       = datestr(startDateNum+day-1);
        timeStamp                       = datestr(now);
        disp('Lser for dag:');
        disp(dayToSave);
        %get info
        dateNumber                      = infoMatrix(idx+day-1,1);
        WaterValue                      = infoMatrix(idx+day-1,2);
        head                            = infoMatrix(idx+day-1,3);
        % = {[2018,3,20,12,00,00]};c
        SRMC                            = infoMatrix(idx+day-1,4); 
        EURtoNOK                        = infoMatrix(idx+day-1,5);
        SpotPrice                       = infoMatrix(idx+day-1,6:9);
        spotCommitment                  = infoMatrix(idx+day-1,10:13);
        
        % for simulation, get spot 24 elements
        spotStateSimVec                 = spotPriceStateMatrix(idx+day-1,:);
        spotPriceSimVec                 = spotPriceMatrix_notStates(idx+day-1,:);
        if idx == 1
            spotCommitmentLastBlockDayBefore = 0;
        else             
            spotCommitmentLastBlockDayBefore = infoMatrix(idx+day-2,13);
        end
        commitmentInSpotVec             = [spotCommitmentLastBlockDayBefore spotCommitment spotCommitment(1)]; 
% Create contingency plan
%% OLD program interface begins here:
        %totNetwork      = program_interface_DP_CP(WaterValue,head,dateNumber,SRMC,EURtoNOK,commitmentInSpot);
%% Create node matrix and RI matrix for 'day'
        disp('Creating NodeMatrix for the given input parameters, please wait...')
        [nodeMatrix, C_R_Matrix, sortData, CapSet, maxCap, priceVecLevels, distinctValueIndices, priceMatrix,combinationCapLeft,waterValuePerCubic] = createNodeMatrix_CP(WaterValue,head,dateNumber,SRMC,EURtoNOK);
        disp('NodeMatrix and IR matrices are made.');
%% Calculate start/stop cost for the given water value. *Indep of production.
        prod                    = 25; % could take any value. Only purpose is to find C_ss for current vv and head. OBS: actually varies slightly for different prod.
        [MC, AC]                 = MCSoeaG1Global(prod,WaterValue,waterValuePerCubic,3,head,-1,'Pnett',EURtoNOK,'EUR/MWh');
        [MCplusFC, ACplusFS]     = MCSoeaG1Global(prod,WaterValue,waterValuePerCubic,3,head,-1,'Pnett',EURtoNOK,'EUR/MWh',prod);
        C_ss                    = (MCplusFC -  MC)*prod;
        disp('Start/stop cost is calculated and equal to:');
        disp(C_ss);
%% Get the transition matrix
        load('big_PMatrix_Master.mat') % pMatrix kommer ut
%% Determine 'runBeforeDay' & 'runAfterDay' from commitmentInSpot.
% For all blocks, determine what capacity level it is closest to. Set 0-1
% depending on whether or not the system is running. 
% Check the first and last elements in 'commitmentInSpot'. Set them equal to the element in CapSet they are
% closest to. If this element is the highest capacity, then set
% running to 0.
        capLeftInitialVec       = maxCap - commitmentInSpotVec; % calculate capLeft before rounding to nearest capLeft level.
        diffMatrix              = zeros(length(commitmentInSpotVec),length(CapSet));
        capCorr                 = zeros(1,length(commitmentInSpotVec));
        runCorr_init            = zeros(1,length(commitmentInSpotVec));
% Round to nearest capLeft level
        for commitmentElements = 1:length(capLeftInitialVec)            
            for comparisonElementInCapSet =1:length(CapSet)
               diffMatrix(commitmentElements,comparisonElementInCapSet)     = abs(CapSet(comparisonElementInCapSet)-capLeftInitialVec(commitmentElements)); 
            end
            [~,idxCorr]                                    = min(diffMatrix(commitmentElements,:));
% capCorr is the vector that describes the capLeft status to compare with nodes in the DP.            
            capCorr(commitmentElements)                    = CapSet(idxCorr);
            if capCorr(commitmentElements) == max(CapSet)
               runCorr_init(commitmentElements) = 0;
            else
               runCorr_init(commitmentElements) = 1;
            end
        end
% Determine index of the corresponding capSet-valiue.
% set values to the set value closest 
% set values to 0/1 
        if capCorr(1) == max(CapSet) % capBefore == max(CapSet)
            runBeforeDay            = 0; % no production when 100 % capLeft
        else
            runBeforeDay            = 1;
        end
        if capCorr(end) == max(CapSet) %capAfter == max(CapSet)
            runAfterDay             = 0;
        else
            runAfterDay             = 1;
        end                
% Round to nearest price level
        diffMatrixPrice             = zeros(length(SpotPrice),length(priceVecLevels));
        priceCorr                   = zeros(1,length(SpotPrice));
        for spotPriceElements = 1:length(SpotPrice)            
            for comparisonElementInPriceSet =1:length(priceVecLevels)
               diffMatrixPrice(spotPriceElements,comparisonElementInPriceSet)     = abs(priceVecLevels(comparisonElementInPriceSet)-SpotPrice(spotPriceElements)); 
            end
            [~,idxCorrP]                    = min(diffMatrixPrice(spotPriceElements));
% capCorr is the vector that describes the capLeft status to compare with nodes in the DP.            
            priceCorr(spotPriceElements)    = priceVecLevels(idxCorrP);
        end
        disp('Initialize day:')
        toc
        %load('SDP_17-Jun-2017_30-May-2018 16_17_04.mat') % tot_SDP_14May
%         totNetwork = SDP_network;

%%%%%%%%%%% PNE IGJEN


       totNetwork                           = DP_CP(nodeMatrix,pMatrix,C_R_Matrix,C_ss,sortData,runBeforeDay,runAfterDay,distinctValueIndices,maxCap); % Er totNetwork en matrise eller en tabell?        
        
%         fileName        = '/Users/sunnivareitenbovim/Documents/MATLAB/MASTER/SDP_26-Jul-2017_25-May-2018 18_21_49';
%         totNetwork      = readFromFile(fileName);
        %% Save SDP (totNetwork) to file
        basicName       = 'SDP';
        filnavn         = [basicName '_' dayToSave '_' timeStamp];

        [fid, msg] = fopen(filnavn,'w');
        if (fid > -1)
            numElemSaved = fwrite(fid,totNetwork,'double');
            if numElemSaved 
                disp('SDP er lagret.');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av SDP.');
                disp(dayToSave);
            end
        else
            disp(msg);
        end
        status = fclose(fid)

%separated out for testing purposes!
%%%%% Try it on a saved table!!!
        % finn ut hvilken verdi 1-256 spot cap matcher:
        spotCapIdx                          = find(ismember(round(combinationCapLeft,4),round(capCorr(2:end-1),4),'rows') == 1);
        % Simulations
        bid_blocks                          = 6;
        logicalX_sell_SDP                   = zeros(bid_blocks,nProd_model);
        logicalX_buy_SDP                    = zeros(bid_blocks,nProd_model);
        pricePathMatrix_SDP                 = zeros(nSimulations*6,nProd_model);
        logicalX_sell_DP                    = zeros(bid_blocks,nProd_model);
        logicalX_buy_DP                     = zeros(bid_blocks,nProd_model);
        pricePathMatrix_DP                  = zeros(nSimulations,bid_blocks);
        DP_cap_paths                        = zeros(nSimulations,bid_blocks+1);
        SDP_cap_paths                       = zeros(nSimulations,bid_blocks+1);
        DP_CP_paths                         = zeros(nSimulations,bid_blocks);
        SDP_CP_paths                        = zeros(nSimulations,bid_blocks+1);
        DP_P_paths                          = zeros(nSimulations,bid_blocks);
        SDP_P_paths                         = zeros(bid_blocks,nProd_model,nSimulations);

        accumCostToGo_SDP                   = zeros(1,bid_blocks);
        accumCostToGo_DP                    = zeros(1,bid_blocks);
        parfor simulation = 1:nSimulations   
            if mod(simulation,200) == 0
                disp(simulation);
            end
            [objectiveValue_LB,decisionX_t_SDP,associatedModelPricePath,SDP_nodeIdxC, SDP_nodeIdxCP,objValVec_SDP] = moveThrough_SDP_CP(totNetwork,nodeMatrix,priceMatrix,capCorr,runCorr_init,bid_blocks,nProd_model,C_ss,spotStateSimVec,spotPriceSimVec,simProdHr,simBidHrTot,P,levelLimits,meanPriceInLevel,grenseVerdierUpper,CapSet,accumHours);
% Akkumuler cost-to-go fun. for DP           
            accumCostToGo_SDP                   = accumCostToGo_SDP + objVal_SDP;
            
%             pricePathMatrix_SDP((simulation-1) * 6 + 1: (simulation-1) * 6 + 6,:) = associatedModelPricePath;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % FOR KOPIERING AV SAMME PRICE PATH FOR LB OG UB
%             simulated_associatedModelPricePath  = associatedModelPricePath;
%             nodeIdxP                            = zeros(1,bid_blocks);
%             for steg = 1:size(simulated_associatedModelPricePath,1)
%                 P_step = round(simulated_associatedModelPricePath(steg,:),4);
%                 nodeIdxP(steg)                  =  find(ismember(round(priceMatrix,4),P_step,'rows') == 1);
%             end
%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FOR SIMULERING AV NY PRICE PATH TIL UB           
            simulated_associatedModelPricePath  = simulatePricePath(nProd_model,simProdHr,simBidHrTot,bid_blocks,priceMatrix,P,levelLimits,meanPriceInLevel,grenseVerdierUpper,spotStateSimVec,spotPriceSimVec);
            nodeIdxP                            = zeros(1,bid_blocks);
            for steg = 1:size(simulated_associatedModelPricePath,1)
                P_step = round(simulated_associatedModelPricePath(steg,:),4);
                nodeIdxP(steg)                  =  find(ismember(round(priceMatrix,4),P_step,'rows') == 1);
            end
%%%%%%%%%%%%%%%%%%%%%%%%%%%            
% Lser DP og finner sti som flge av initiell kapasitet
            [objectiveValue_UB, policy_UB]      = createDeterministic_DP_CP(nodeMatrix,C_R_Matrix,C_ss,sortData,runBeforeDay,runAfterDay,nodeIdxP,maxCap);
            [decisionX_t_DP, DP_nodeIdxC, DP_nodeIdxCP, objVal_DP]      = moveThrough_DP_CP(policy_UB,spotCapIdx,bid_blocks);
            
%Lagrer upper og lower bound            
            LB_matrix(simulation,day)           = objectiveValue_LB; % ?
            UB_matrix(simulation,day)           = objectiveValue_UB(spotCapIdx); 
%Lagrer CP-stier for hver simulering            
            DP_cap_paths(simulation,:)          = DP_nodeIdxC;
            DP_CP_paths(simulation,:)           = DP_nodeIdxCP;
            SDP_cap_paths(simulation,:)         = SDP_nodeIdxC;
            SDP_CP_paths(simulation,:)          = SDP_nodeIdxCP;
%Lagrer P-stier for hver simulering. Fra SDP i matrise [6,4], fra DP i
%nodevektor [1,6]
            DP_P_paths(simulation,:)            = nodeIdxP;
            SDP_P_paths(:,:,simulation)         = associatedModelPricePath;
% Akkumuler cost-to-go fun. for DP           
            accumCostToGo_DP                   = accumCostToGo_DP + objVal_DP;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Accumulate the trades in SDP times over multiple simulations
% get the decision matrix. Make a logical matrix to see when the products
% are traded. Interesting after many simulations within the day.
% x: format 6*8. Save in the same manner as bounds are saved. One file: [xs,
% xb]
            logicalX_sell_SDP                       = logicalX_sell_SDP + logical(decisionX_t_SDP(:,1:4)); % accumulating trades from the day.
            logicalX_buy_SDP                        = logicalX_buy_SDP  + logical(decisionX_t_SDP(:,5:8));

% Tilsvarende for DP. M vente til x-output er klar.
           logicalX_sell_DP                       = logicalX_sell_DP + logical(decisionX_t_DP(:,1:4)); % accumulating trades from the day.
           logicalX_buy_DP                        = logicalX_buy_DP  + logical(decisionX_t_DP(:,5:8));

            %% Save DP (policy_UB) to file
            %Denne tas bort nr vi har sjekket at DP funker.
            %IKKE kjr med denne for mange simuleringer!
            if (simulation == 1) || (simulation == nSimulations)
                if (day == (accumLength-12)|| day == 1)  % kan ikke lagre alle DP totmatriser, lagrer den siste og den frste.
                    simNum      = num2str(simulation);
                    basicName   = 'DP';
                    filnavn     = [basicName '_' dayToSave '_' simNum '_' timeStamp];
                    
                    [fid, msg] = fopen(filnavn,'w');
                    if (fid > -1)
                        numElemSaved = fwrite(fid,policy_UB,'double');
                        if numElemSaved
                            disp('DP er lagret for simulering:');
                            disp(simNum);
                        else
                            disp('Noe kan ha gtt galt under lagring av DP for simulering:');
                            disp(simNum);
                        end
                    else
                        disp(msg);
                    end
                    status = fclose(fid)
                end
            end
            
         end % simulation
         disp('Simulation time');
         toc
         
% Plot utfallene av prissimuleringer slik de tolkes av modellen (akkumulert). 1  subplot per produkt:
% figure;
%         for prod =1:nProd_model
%             subplot(4,1,prod);
%             for sim = 1:nSimulations
%                 path = pricePathMatrix_SDP((sim-1) * 6 +  1 : (sim-1) * 6 + 6,prod);
%                 plot(path);
%                 hold on
%             end
%         end
% 
        %% Save LB and UB matrix to file
        basicName = 'Bounds';
        filnavn = [basicName '_' dayToSave];
        bounds_matrix = [LB_matrix UB_matrix];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,bounds_matrix,'double');
            if numElemSaved 
                disp('LB og UB er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av LB og UB for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid)     

        %% Save accumulated trades SDP
        basicName_SDP = 'SDP_AccumTrades';
        filnavn = [basicName_SDP '_' dayToSave];
        trades_matrix_SDP = [logicalX_sell_SDP logicalX_buy_SDP];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,trades_matrix_SDP,'double');
            if numElemSaved 
                disp('Accum trade matrix er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av LB og UB for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid) 

        %% Save accumulated trades DP
        basicName_DP = 'DP_AccumTrades';
        filnavn = [basicName_DP '_' dayToSave];
        trades_matrix_DP = [logicalX_sell_DP logicalX_buy_DP];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,trades_matrix_DP,'double');
            if numElemSaved 
                disp('Accum trade matrix er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av LB og UB for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid) 
        
        %% Save accumulated trades DP
        basicName_DP = 'DP_AccumTrades';
        filnavn = [basicName_DP '_' dayToSave];
        trades_matrix_DP = [logicalX_sell_DP logicalX_buy_DP];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,trades_matrix_DP,'double');
            if numElemSaved 
                disp('Accum trade matrix er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av LB og UB for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid) 
        
%% Save accumulated cost to go func for SDP
        basicName = 'SDP_CostToGoVec';
        filnavn = [basicName '_' dayToSave];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,accumCostToGo_SDP,'double');
            if numElemSaved 
                disp('Accumulated cost-to-go func er lagret for SDP:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av cost-to-go func for SDP for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid)           
        
%% Save accumulated cost to go func for DP
        basicName = 'DP_CostToGoVec';
        filnavn = [basicName '_' dayToSave];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,accumCostToGo_DP,'double');
            if numElemSaved 
                disp('Accumulated cost-to-go func er lagret for DP:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av cost-to-go func for DP for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid)       
        
        
        %% Save capacity paths DP
        basicName = 'DP_C_paths';
        filnavn = [basicName '_' dayToSave];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,DP_cap_paths,'double');
            if numElemSaved 
                disp('DP capacity paths er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av DP capacity paths for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid) 
        
        %% Save CP paths SDP
        basicName = 'SDP_CP_paths';
        filnavn = [basicName '_' dayToSave];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,SDP_CP_paths,'double');
            if numElemSaved 
                disp('SDP CP paths er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av SDP CP paths for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid) 
        
        %% Save CP paths DP
        basicName = 'DP_CP_paths';
        filnavn = [basicName '_' dayToSave];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,DP_CP_paths,'double');
            if numElemSaved 
                disp('DP CP paths er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av DP CP paths for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid)         
        
%             DP_cap_paths(simulation,:)          = DP_nodeIdxC;
%             DP_CP_paths(simulation,:)           = DP_nodeIdxCP;
%             SDP_cap_paths(simulation,:)         = SDP_nodeIdxC;
%             SDP_CP_paths(simulation,:)          = SDP_nodeIdxCP;

        %% Save P-paths DP
        basicName = 'DP_P_paths';
        filnavn = [basicName '_' dayToSave];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,DP_P_paths,'double');
            if numElemSaved 
                disp('DP Price paths er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av DP Price paths for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid)          
        %% Save P-paths SDP
        basicName = 'SDP_P_paths';
        filnavn = [basicName '_' dayToSave];
        
        [fid, msg] = fopen(filnavn,'a');
        if (fid > -1)
            numElemSaved = fwrite(fid,SDP_P_paths,'double');
            if numElemSaved 
                disp('SDP Price paths er lagret for dag:');
                disp(dayToSave);
            else 
                disp('Noe kan ha gtt galt under lagring av SDP Price paths for dag:');
                disp(dayToSave)
            end
        else
            disp(msg);
        end
        status = fclose(fid)         
%             DP_P_paths(simulation,:)            = nodeIdxP;
%             SDP_P_paths(:,:,simulation)         = associatedModelPricePath;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
        end
    delete(gcp('nocreate'));
    disp('came here')
end