function [decisionX_t,nodeIdxC,nodeIdxCP,objValVec_DP] = moveThrough_DP_CP(totNetworkDP,spotCapIdx,Time_blocks)
% This version simulates prices in the real problem hour by hour.
% 1. Work trough the contingency plan and make the best decisions given a
% set of simulated block prices.
%% Finner runCorr_init
        runCorr_init            = zeros(1,length(commitmentInSpotVec));
% Round to nearest capLeft level
        for commitmentElements = 1:length(capLeftInitialVec)            
            for comparisonElementInCapSet =1:length(CapSet)
               diffMatrix(commitmentElements,comparisonElementInCapSet)     = abs(CapSet(comparisonElementInCapSet)-capLeftInitialVec(commitmentElements)); 
            end
            [~,idxCorr]                                    = min(diffMatrix(commitmentElements,:));
% capCorr is the vector that describes the capLeft status to compare with nodes in the DP.            
            capCorr(commitmentElements)                    = CapSet(idxCorr);
            if capCorr(commitmentElements) == max(CapSet)
               runCorr_init(commitmentElements) = 0;
            else
               runCorr_init(commitmentElements) = 1;
            end
        end
%% totNetwork represent the contingency plan.  
        nodeIdxC                    = zeros(1,Time_blocks+1); % Values in the range: 1-256
        nodeIdxCP                   = zeros(1,Time_blocks); % Values in the range: 1-160000
%% Simulate the price. It is found by simulating independent price paths for all 24 products (dep on spot) 
        nodeIdxC(1)                 = spotCapIdx;
%         cap_interval                = (spotCapIdx-1)*625+1:spotCapIdx*625;
%         nodeIdxCP(1)                = (spotCapIdx-1)*625+find(~ismissing(totNetworkDP(cap_interval,13)));        
% Generate the price matrix to determine the index of the first state: 
        decisionX_t                  = zeros(Time_blocks,8);
        objectiveValue               = 0;
        objValVec_DP                    = zeros(1,Time_blocks);
       %% Loop through the tree using price information as it is revealed.        
        for model_step = 1:Time_blocks          
% Price in step is known, make decisions x:
            cap_interval             = ((nodeIdxC(model_step)-1)*625+1):(nodeIdxC(model_step)*625);
            nodeIdxCP(model_step)    = (nodeIdxC(model_step)-1)*625+find(~ismissing(totNetworkDP(cap_interval,12+(model_step)*10)));
            decisionX_t(model_step,:)= totNetworkDP(nodeIdxCP(model_step),13+(model_step-1)*10:20+(model_step-1)*10); % get 8 dec var per step
            nodeIdxC(model_step+1)   = totNetworkDP(nodeIdxCP(model_step),12+(model_step)*10);
%% Inn fra SDP for  berenge cost-to-go            
            MCprod_prev               = nodeMatrix(nodeIdxCP(1),13:16);
            MCprod_next               = nodeMatrix(nodeIdxCP(end),13:16); % Adding the marginal cost of final production. 
            maxCapVec                 = max(CapSet)*ones(1,4);
            cap_prev                  = nodeMatrix(nodeIdxCP(1),1:4);
            cap_next                  = nodeMatrix(nodeIdxCP(end),1:4);
            prod_prev                 = maxCapVec - cap_prev;
            prod_next                 = maxCapVec - cap_next;
      % objectiveValue            = objectiveValue - sum(MCprod_final.*decisionX_t(Time_blocks,:)); %subtract marginal cost of actual production       
            objectiveValue            = objectiveValue - accumHours*(sum(  (MCprod_next.* prod_next ) - (MCprod_prev.*prod_prev )  ));
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
%% Determine the change in fixed costs between spot plan and final running plan:
% The deviations may and may not have resulted in introduction of or cancellation of fixed costs.  
% Start by counting # start/stop costs in step t.
            run_next = totNetwork(nodeIdxCP(end),9:12); % Get final running plan
            startsNstops_prev           = 0;
            startsNstops_next           = 0;
            if model_step == 1
               run_prev = runCorr_init;
            end
            for R_element = 1:length(run_prev)-1
                if (run_prev(R_element+1)-run_prev(R_element) == 1)
                    startsNstops_prev                     = startsNstops_prev + 1;
                end
                if R_element < 4
                    if (run_next(R_element+1)-run_next(R_element) == 1)
                        startsNstops_next                 = startsNstops_next + 1;
                    end
                end
            end           
% switch prev in each step            
            run_prev = run_next;
%% Compare the number of starts/stops. alpha is positive, zero or negative. 
            alpha                     = startsNstops_next - startsNstops_prev; 
            startStopCost_final       = alpha * C_ss;
            objectiveValue            = objectiveValue - startStopCost_final;  
            objValVec_DP(model_step)     = objectiveValue; 
            
            
            
            
            
%             if model_step == 1
%                 P_step                 = round(associatedModelPricePath(model_step,:),4); % samme som over?
%                 nodeIdxP(model_step)   = find(ismember(round(priceMatrix,4),P_step,'rows') == 1);
%            else
%                P_step                  = p_next;
%            end           
%            objectiveCoeffs             = [P_step*(1+perCentDeviation),-(P_step*(1-perCentDeviation))];           
%            decisionX_t(model_step,:)   = totNetworkDP(nodeIdxCP(model_step),13+(model_step-1)*10:20+(model_step-1)*10); % get 8 dec var per step
%            objectiveValue              = objectiveValue + accumHours*(sum(objectiveCoeffs.*decisionX_t(model_step,:))); 
% Bestem ny C og CP vha. avlesning i matrise.
%             nodeIdxC(model_step+1)   = totNetworkDP(nodeIdxCP(model_step),12+(model_step)*10);
%            if model_step < Time_blocks
%                p_next                   = round(associatedModelPricePath(model_step+1,:),4);
%                nodeIdxP(model_step+1)   = find(ismember(round(priceMatrix,4),p_next,'rows') == 1);
% % %                nodeIdxC(model_step+1)   = totNetwork(nodeIdxCP(model_step),12+(model_step)*10);
% %                nodeIdxCP(model_step+1)  = ((nodeIdxC(model_step+1)-1) * 625) + nodeIdxP(model_step+1); % CORRECT?
% %            else
% %                nodeIdxCP(model_step+1)  = ((nodeIdxC(model_step+1)-1) * 625) + 1;
% %            end
% % akkumulere price paths i begge retninge. Rund av til stateverdier(?).           
%             %% gjr riktig for alle steps!!
%          %  priceState_t                = totNetwork(nodeIdxCP(model_step),5:8);
%            % priceStateObj         = [priceState_t * (1+perCentDeviation),priceState_t *(1-perCentDeviation)];
%            % Determine objective value for the given P and x in step t. Save fixed cost calculation: MC (?) and start stop to the end. 
%            
         end   
% %        MCprod_spot               = nodeMatrix(nodeIdxCP(1),13:16);
% %        MCprod_final              = nodeMatrix(nodeIdxCP(end),13:16); % Adding the marginal cost of final production. 
% %        maxCapVec                 = max(CapSet)*ones(1,4);
% %        cap_spot                  = nodeMatrix(nodeIdxCP(1),1:4);
% %        cap_final                 = nodeMatrix(nodeIdxCP(end),1:4);
% %        prod_spot                 = maxCapVec - cap_spot;
% %        prod_final                = maxCapVec - cap_final;
% %       % objectiveValue            = objectiveValue - sum(MCprod_final.*decisionX_t(Time_blocks,:)); %subtract marginal cost of actual production       
% %        objectiveValue            = objectiveValue - accumHours*(sum(  (MCprod_final.* prod_final ) - (MCprod_spot.*prod_spot )  ));
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
% %% Determine the change in fixed costs between spot plan and final running plan:
% % The deviations may and may not have resulted in introduction of or cancellation of fixed costs.  
% % Start by counting # start/stop costs in step t.
%         run_T = totNetworkDP(nodeIdxCP(end),9:12); % Get final running plan
%         startsNstops_spot        = 0;
%         startsNstops_T           = 0;
%         for R_element = 1:length(runCorr_init)-1
%             if (runCorr_init(R_element+1)-runCorr_init(R_element) == 1)
%                 startsNstops_spot                 = startsNstops_spot + 1;
%             end
%             if R_element < 4
%                 if (run_T(R_element+1)-run_T(R_element) == 1)
%                     startsNstops_T                 = startsNstops_T + 1;
%                 end
%             end
%         end           
% %% Compare the number of starts/stops. alpha is positive, zero or negative. 
%        alpha                     = startsNstops_T - startsNstops_spot;
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%        startStopCost_final       = alpha * C_ss;
%        objectiveValue            = objectiveValue - startStopCost_final;       
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
% % Plot capacity changes: % prve  bruk SAMME simulerte path p DP og SDP
% % for  finne feil i beregnining. Nr blir den ene altfor hy?
%        if plotCap == 1
%            null = plotCapacityDevelopment(totNetworkDP, nodeIdxCP);
%           
%        end       
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



    end