function [objectiveValue,decisionX_t,associatedModelPricePath,nodeIdxC,nodeIdxCP,objValVec_SDP,EV_Obj] = moveThrough_SDP_CP(totNetwork,nodeMatrix,priceMatrix,capCorr,runCorr_init,Time_blocks,nProd_model,C_ss,spotStateSimVec,spotPriceSimVec,simProdHr,simBidHrTot,P,levelLimits,meanPriceInLevel,grenseVerdierUpper,CapSet,accumHours)
% This version simulates prices in the real problem hour by hour.
% 1. Work trough the contingency plan and make the best decisions given a
% set of simulated block prices.
%%%%%%%%%%% %%%%%%%%%%% %%%%%%%%%%%
%% totNetwork represent the contingency plan.
% Initial state can be found using initial spot prices for all blocks and
% initial running plan as a basis for capLeft:
        initialCapLeftState         = round(capCorr,4);
        perCentDeviation            = 0.054569465060199; % Keep?        
        nodeIdxC                    = zeros(1,Time_blocks+1); % Values in the range: 1-256
        nodeIdxP                    = zeros(1,Time_blocks); % Values in the range: 1-625
        nodeIdxCP                   = zeros(1,Time_blocks); % Values in the range: 1-160000
%% Simulate the price. It is found by simulating independent price paths for all 24 products (dep on spot)
        associatedModelPricePath    = simulatePricePath(nProd_model,simProdHr,simBidHrTot,Time_blocks,priceMatrix,P,levelLimits,meanPriceInLevel,grenseVerdierUpper,spotStateSimVec,spotPriceSimVec);
% har dermed den simulerte price pathen   
        initialPrices               = round(associatedModelPricePath(1,:),4); 
        initialState                = [initialCapLeftState(2:end-1),initialPrices];
        % Describe indices throughout the path.    
        nodeIdxCP(1)                = find(ismember(round(totNetwork(:,1:8),4),initialState,'rows') == 1); % 1:8 => CP spots
        nodeIdxC(1)                 = find(ismember(round(nodeMatrix(:,1:4),4),initialState(1:4),'rows')==1,1);
% Generate the price matrix to determine the index of the first state: 
        decisionX_t                  = zeros(Time_blocks,8);
        objectiveValue               = 0;
        objValVec_SDP                = zeros(1,Time_blocks);
% Find and store expected value when looping through SDP        
        EV_Obj                       = zeros(1,Time_blocks);
        
       %% Loop through the tree using price information as it is revealed.        
        for model_step = 1:Time_blocks          
% Price in step is known, make decisions x:           
           if model_step == 1
                P_step                 = round(associatedModelPricePath(model_step,:),4); % samme som over?
                nodeIdxP(model_step)   = find(ismember(round(priceMatrix,4),P_step,'rows') == 1);
           else
               P_step                  = p_next;
           end           
           objectiveCoeffs             = [P_step*(1+perCentDeviation),-(P_step*(1-perCentDeviation))];           
           decisionX_t(model_step,:)   = totNetwork(nodeIdxCP(model_step),13+(model_step-1)*10:20+(model_step-1)*10); % get 8 dec var per step
           EV_Obj(model_step)          = totNetwork(nodeIdxCP(model_step),21+(model_step-1)*10); % riktig?
           objectiveValue              = objectiveValue + accumHours*(sum(objectiveCoeffs.*decisionX_t(model_step,:))); 
% Bestem ny C og CP vha. avlesning i matrise.
            nodeIdxC(model_step+1)   = totNetwork(nodeIdxCP(model_step),12+(model_step)*10);
           if model_step < Time_blocks
               p_next                   = round(associatedModelPricePath(model_step+1,:),4);
               nodeIdxP(model_step+1)   = find(ismember(round(priceMatrix,4),p_next,'rows') == 1);
%                nodeIdxC(model_step+1)   = totNetwork(nodeIdxCP(model_step),12+(model_step)*10);
               nodeIdxCP(model_step+1)  = ((nodeIdxC(model_step+1)-1) * 625) + nodeIdxP(model_step+1); % CORRECT?
           else
               nodeIdxCP(model_step+1)  = ((nodeIdxC(model_step+1)-1) * 625) + 1;
           end           
% akkumulere price paths i begge retninge. Rund av til stateverdier(?).           
            %% gjr riktig for alle steps!!
         %  priceState_t                = totNetwork(nodeIdxCP(model_step),5:8);
           % priceStateObj         = [priceState_t * (1+perCentDeviation),priceState_t *(1-perCentDeviation)];
           % Determine objective value for the given P and x in step t. Save fixed cost calculation: MC (?) and start stop to the end. 
            MCprod_prev               = nodeMatrix(nodeIdxCP(1),13:16);
            MCprod_next               = nodeMatrix(nodeIdxCP(end),13:16); % Adding the marginal cost of final production. 
            maxCapVec                 = max(CapSet)*ones(1,4);
            cap_prev                  = nodeMatrix(nodeIdxCP(1),1:4);
            cap_next                  = nodeMatrix(nodeIdxCP(end),1:4);
            prod_prev                 = maxCapVec - cap_prev;
            prod_next                 = maxCapVec - cap_next;
      % objectiveValue            = objectiveValue - sum(MCprod_final.*decisionX_t(Time_blocks,:)); %subtract marginal cost of actual production       
            objectiveValue            = objectiveValue - accumHours*(sum(  (MCprod_next.* prod_next ) - (MCprod_prev.*prod_prev )  ));
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
%% Determine the change in fixed costs between spot plan and final running plan:
% The deviations may and may not have resulted in introduction of or cancellation of fixed costs.  
% Start by counting # start/stop costs in step t.
            run_next = totNetwork(nodeIdxCP(end),9:12); % Get final running plan
            startsNstops_prev           = 0;
            startsNstops_next           = 0;
            if model_step == 1
               run_prev = runCorr_init;
            end
            for R_element = 1:length(run_prev)-1
                if (run_prev(R_element+1)-run_prev(R_element) == 1)
                    startsNstops_prev                     = startsNstops_prev + 1;
                end
                if R_element < 4
                    if (run_next(R_element+1)-run_next(R_element) == 1)
                        startsNstops_next                 = startsNstops_next + 1;
                    end
                end
            end           
% switch prev in each step            
            run_prev = run_next;
%% Compare the number of starts/stops. alpha is positive, zero or negative. 
            alpha                     = startsNstops_next - startsNstops_prev; 
            startStopCost_final       = alpha * C_ss;
            objectiveValue            = objectiveValue - startStopCost_final;  
            objValVec_SDP(model_step) = objectiveValue;       
        end       
%         if plotCap == 1
%            null = plotCapacityDevelopment(totNetwork, nodeIdxCP);
%           
%        end       
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    end