%% Function to calculate objective value and optimal decision
function [maxValue, optimalSolutionVec, maxIndexRow] = objValAndDecisions_CP(priceState, capState, runningState, futureValueVec, CR_Matrix,start_stop_cost,MC_vec_t,bh,nn,intervals,runBeforeDay,runAfterDay,maxCap)%futureValueMatrix
%tic
%% Takes in a matrix that describes the possible outcomes in the next step 
% Must loop through all rows associated with combinations of R and C.
% They correspond to different constraints, and hence yields different
% feasible and optimal solutions. Must also add the optimal value in
% step t with that of later steps, which is also stored in the matrix.
% To optimize in this node, pick the option with the largest added value.
%% Basic information of node
bidHour         = bh;
nodeToSolve     = nn;
nodeStructure   = intervals;
numHours_bolk   = 6;
%% Price vec
% Investigate further the difference between sell and buy prices.
    priceVecState                                     = priceState;
    perCentDeviation                                  = 0.054569465060199; %0.028049408476644 * 100; %found from analysis
    sellPriceVec                                      = priceVecState * (1+perCentDeviation); % Adjust for analysis results.
    buyPriceVec                                       = priceVecState * (1-perCentDeviation); % change function based on results from PCA
%% Running vec    
    runVec_t                                          = runningState;
    extended_runVec_t                                 = [runBeforeDay runVec_t runAfterDay];
%% Capacity vec
    CapLeftVec                                        = capState;
    maxCapVec                                         = maxCap*ones(1,length(CapLeftVec));
    prodVec                                           = maxCapVec-capState;
%% Marginal cost vec
    MCvec_t                                           = MC_vec_t;
%% Counting start/stop planned in hr t:
    startsNstops_t                                    = 0;
    for R_element = 1:length(extended_runVec_t)-1
        if extended_runVec_t(R_element+1)-extended_runVec_t(R_element) == 1
            startsNstops_t = startsNstops_t + 1;
        end
    end   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Obtaining valid future nodes (noe ikke-generisk)
next_ph                 = bidHour -2;
numPH                   = length(sellPriceVec);
numPriceCombos          = 5^numPH;                      %5 = antall prisniv
numCcombos              = 4^numPH;                      %4 = antall capniv
priceInNode             = mod(nodeToSolve-1,numPriceCombos)+1;
equivalentCstructure    = nodeStructure/numPriceCombos;
equivalentCindex        = find(ismember(CR_Matrix(:,1:4),capState,'rows'));
startIndeks             = mod(equivalentCindex-1,equivalentCstructure(numPH))+1;

indekser                = zeros(numCcombos,1);          %skal settes lik 1 dersom de er gyldige fremtidige kapasiteter



    if next_ph > 0
       index = startIndeks;
       %Finner alle ulike C-kombinasjoner for relevante ph
       while index < length(indekser)
           %index
           indekser(index) = 1;
           index = index + equivalentCstructure(next_ph);
       end
       RC_IndiceVec = find(indekser);
    else
       RC_IndiceVec = find(~indekser); 
    end  
%% Creating a matrix to store decicions in
%objMatrix                                              = [CR_Matrix(:,1:8) futureValueVec' zeros(size(futureValueVec,2),10)]; % to store obj_small and 8 x-values and total_value. Also store original row. % obj_t+1(1),x_t(8),obj_small(1),obj_t(1).
objMatrix                                               = NaN(numCcombos,19);
%% Loop through all combinations or R and C vectors    
    for valid_RCcombo = 1:length(RC_IndiceVec) 
%% Marginal cost - possible to to outside loop for speed?
        capVec_t_plus_1                                 = CR_Matrix(RC_IndiceVec(valid_RCcombo),1:4); %[4.5 4.5 4.5 4.5];
        runVec_t_plus_1                                 = CR_Matrix(RC_IndiceVec(valid_RCcombo),5:8); %[1 1 1 1];  
        futureValue                                     = futureValueVec(RC_IndiceVec(valid_RCcombo));
%         capVec_t_plus_1                                 = objMatrix(RC_IndiceVec(valid_RCcombo),1:4); %[4.5 4.5 4.5 4.5];
%         runVec_t_plus_1                                 = objMatrix(RC_IndiceVec(valid_RCcombo),5:8); %[1 1 1 1];  
        MCVec_t_plus_1                                  = CR_Matrix(RC_IndiceVec(valid_RCcombo),9:12); % insert a function for MC? 
        prodVec_t_plus_1                                = maxCapVec - capVec_t_plus_1;
%% Objective function coefficients         
%        objCoeffVariablePremiumSell                     = sellPriceVec - MCVec_t_plus_1;
%        objCoeffVariablePremiumBuy                      = MCVec_t_plus_1 - buyPriceVec;      
        objective                                       = [sellPriceVec, -buyPriceVec];  % subtract alpha * fixed cost, and MC*cap      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% To consider start and stop costs:      
        extended_runVec_t_plus_1                        = [runBeforeDay runVec_t_plus_1 runAfterDay];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Calculate 
% The deviations may and may not have resulted in introduction of or cancellation of fixed costs.  
% Start by counting # start/stop costs in step t.
        startsNstops_t_plus_1                         = 0;
        for R_element = 1:length(extended_runVec_t_plus_1)-1
            if extended_runVec_t_plus_1(R_element+1)-extended_runVec_t_plus_1(R_element) == 1
                startsNstops_t_plus_1                 = startsNstops_t_plus_1 + 1;
            end
        end   
%% Compare the number of starts/stops. alpha is positive, zero or negative. 
        alpha                                         = startsNstops_t_plus_1 - startsNstops_t;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Gammel kode
% x1 = zeros(1,8);
% xs_bound = 200;
%     % If delta c is pos, X^s > X^b
%         deltaCap                                        = (CapLeftVec - capVec_t_plus_1);
%         X_s_largerThan_X_b                              = logical(deltaCap >= 0);
%         marginalUnitPremium                             = objCoeffVariablePremiumSell + objCoeffVariablePremiumBuy;
%         pos_marginal_premium                            = logical(marginalUnitPremium >= 0);
% 
%         for elem = 1:length(marginalUnitPremium)
%             if X_s_largerThan_X_b(elem) == 1
%                 if pos_marginal_premium(elem) == 1
%                     x1(elem) = xs_bound;
%                     x1(elem+4) = xs_bound - abs(deltaCap(elem));
%                  else  %% OBS!! WILL NOT OCCUR WHEN PRICE IS +- P. MC cancels...
%                      x1(elem) = deltaCap(elem);
%                      x1(elem+4) = 0;
%                 end
%             else % X_s_largerThan_X_b(elem) == 0
%                  if pos_marginal_premium(elem) == 1
%                     x1(elem) = xs_bound;
%                     x1(elem+4) = xs_bound + abs(deltaCap(elem));
%                 else
%                     x1(elem) = 0;
%                     x1(elem+4) = deltaCap(elem);
%                   end   
%             end
%         end
        
%% Find optimal solution
        x1 = zeros(1,8);
% Only sell or buy
        deltaProd                                       = (prodVec_t_plus_1-prodVec);
        X_s_prod                                        = logical(deltaProd > 0);
        X_b_cancelprod                                  = logical(deltaProd < 0);
        for elem = 1:length(deltaProd)   
            if X_s_prod(elem) == 1
                x1(elem) = deltaProd(elem);
            elseif X_b_cancelprod(elem) == 1     
                x1(elem+4) = abs(deltaProd(elem));
            end
        end
        fval2                                          = sum(x1.*objective)-sum(MCVec_t_plus_1.*prodVec_t_plus_1)+sum(MCvec_t.*prodVec);
%% Insert into objMatrix        
        objMatrix(RC_IndiceVec(valid_RCcombo),1:4)                   = capVec_t_plus_1;
        objMatrix(RC_IndiceVec(valid_RCcombo),5:8)                   = runVec_t_plus_1;
        objMatrix(RC_IndiceVec(valid_RCcombo),9)                     = futureValue;
        objMatrix(RC_IndiceVec(valid_RCcombo),10:17)                 = x1; 
        obj_small                                                    = (numHours_bolk*fval2) - (alpha * start_stop_cost);
        objMatrix(RC_IndiceVec(valid_RCcombo),18)                    = obj_small;
% For testing, debug        
%         if RC_IndiceVec(valid_RCcombo)==4081
%             a=1;
%         end    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    end     
    objMatrix(:,19)                                    = objMatrix(:,18) + objMatrix(:,9); %opt in node, given  v_t+1,   v_t+1   
%% Choose the overall best solution (largest objective) in column 10    
    [maxValue, maxIndexRow]                            = max(objMatrix(:,19)); % not invested rows have the value 0 and will not be chosen
    optimalSolutionVec                                 = objMatrix(maxIndexRow,:);
    %toc
end