    % %% Simulate the price. It is found by simulating independent price paths for all 24 products (dep on spot)
    function associatedModelPricePath = simulatePricePath(nProd_model,simProdHr,simBidHrTot,Time_blocks,priceMatrix,P,levelLimits,meanPriceInLevel,grenseVerdierUpper,spotStateSimVec,spotPriceSimVec)
% taking an average of 6 and 6 (get four numbers) price path.
%% Put as inputs?%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


       %get 5x5 matrix
       %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       pMatrix = P;
       %initialize 24 prod paths in a matrix
       pricePaths                   = nan(simBidHrTot+2,simProdHr); % matrix of 36 to get 6x6 elements(states). No values in two first.
       pricePathsRawData            = nan(simBidHrTot+2,simProdHr);  % prices
       pricePathsProdAccum          = nan(simBidHrTot+2,nProd_model);
       pricaPathsProdNTimeAccum     = nan(Time_blocks,nProd_model);
       % get initial price states (in the states of hr by hr
       % transform into states with the hour by hour limits found from
       % categorize (stateTable)    
       pricePaths(3,:)             = spotStateSimVec; %initial state to simulate 24 price paths from
       pricePaths(4,:)             = spotStateSimVec;
       pricePaths(5,:)             = spotStateSimVec;
       pricePaths(6,:)             = spotStateSimVec;
       pricePathsRawData(3,:)      = spotPriceSimVec;
       pricePathsRawData(4,:)      = spotPriceSimVec;
       pricePathsRawData(5,:)      = spotPriceSimVec;
       pricePathsRawData(6,:)      = spotPriceSimVec;
%% Create accumProbVec
       accumProbMatrix = zeros(length(pMatrix));
       for fromState_i = 1:length(pMatrix)
            accumProbVec        = zeros(1,length(pMatrix)); % make a vector for each element i. Insert into an accum matrix
            accumulatedElements = 0;
       for toState_j = 1:length(pMatrix)
            accumulatedElements     = accumulatedElements + pMatrix(fromState_i,toState_j);
            accumProbVec(toState_j) = accumulatedElements;
       end
            accumProbMatrix(fromState_i, :) = accumProbVec;
       end              
%% Simulate the whole path for all steps at once, only reveal stepwise(!).
        for realTime = 7:simBidHrTot+2 %4:simBidHrTot+2
            U_vec               = rand(1,simProdHr);
                for prod = 1:simProdHr % all 24 hrs
                   % sjekk elementvis hva neste pris blir
                    for toState_j = 1:length(pMatrix)
                       if U_vec(prod) <= accumProbMatrix(pricePaths(realTime-1,prod),toState_j)
                      %if U_vec(prod) <= accumProbMatrix(nodeIdxP(model_step-1),toState_j)
                           pricePaths(realTime,prod) = toState_j; % set elements to the associated price
                           pricePathsRawData(realTime,prod) = meanPriceInLevel(toState_j);
                           break;          
                       end              
                    end
                end
        end           
% given the 33x24 matrix of mean prices:
% find avg in both time and prod dimension:
% first avg over products: 33x4 matrix
        pricePathsProdAccum(:,1)        = mean(pricePathsRawData(:,1:6),2);
        pricePathsProdAccum(:,2)        = mean(pricePathsRawData(:,7:12),2);
        pricePathsProdAccum(:,3)        = mean(pricePathsRawData(:,13:18),2);
        pricePathsProdAccum(:,4)        = mean(pricePathsRawData(:,19:24),2); 
% accumulate biddinghours
        pricaPathsProdNTimeAccum(1,:)   = mean(pricePathsProdAccum(3:6,:));
        pricaPathsProdNTimeAccum(2,:)   = mean(pricePathsProdAccum(7:12,:));
        pricaPathsProdNTimeAccum(3,:)   = mean(pricePathsProdAccum(13:18,:));
        pricaPathsProdNTimeAccum(4,:)   = mean(pricePathsProdAccum(19:24,:));
        pricaPathsProdNTimeAccum(5,:)   = mean(pricePathsProdAccum(25:30,:));
        pricaPathsProdNTimeAccum(6,:)   = mean(pricePathsProdAccum(31:36,:));
% use this to find the closest model states. Compare each element with the levelLimits of the 6 by 6 hr limits.        
        associatedModelPricePath        = zeros(size(pricaPathsProdNTimeAccum));
        priceStatesModel                = sort(unique(priceMatrix));
        for statePriceLevel = 1:5  % check all elements in matrix if they are within a state window. Set to corresponding price.         
            elemIdx = logical(pricaPathsProdNTimeAccum<=grenseVerdierUpper(statePriceLevel));
            pricaPathsProdNTimeAccum(elemIdx) = nan; % to not pick the same values over again
            associatedModelPricePath(elemIdx) = priceStatesModel(statePriceLevel);    
        end
    end